IMPLICIT NONE

integer*2, parameter :: ncrop = 161, npays = 215
 character(len=100) :: yentete
integer*2, dimension(ncrop,2) :: ictype
integer*2, dimension(npays,2) :: icpays
real*4, dimension(npays,6) :: zhcult
real*4, dimension(3) :: zread
integer*2 :: jj, icpt, inum1, inum2
integer*4 :: ji

! code culture fourni par JC C3hiver=2,  C3ete=3,  C4=4,  ligneux=0,  autres=1
! associé au code type de la FAO (première colonne)
open(11,file='fao_code.csv',form='formatted')
read(11,fmt=*) yentete
do jj=1,ncrop
  read(11,fmt=*) ictype(jj,:)
enddo
close(11)

zhcult(:,:) = 0
icpt = 1

! contient le code fao du pays, le code fao de la culture, et le nombre d'hectares cultivées
open(12,file='fao_simple2.csv',form='formatted')

read(12,fmt=*) yentete
read(12,fmt=*) zread
! la première colonne contient le code du pays
zhcult(1,1) = zread(1)
! on cherche à quelle culture ce type correspond dans la liste ictype
do jj=1,ncrop
if (int(zread(2))==ictype(jj,1)) then ! si le type de la ligne correspond au type du tableau
    ! zhcult contient une colonne pour chaque type de culture ECOCLIMAP
    ! on somme les hectare par pays
    zhcult(1,ictype(jj,2)+2) = zhcult(1,ictype(jj,2)+2) + zread(3)
    exit
  endif
enddo


! on balaie les lignes du fichier
do ji = 3,9244

  read(12,fmt=*) zread
  ! si on change de pays
  if (zread(1)/=zhcult(icpt,1)) then
    ! on change de ligne du tableau à écrire
    icpt = icpt + 1
    ! on met le code du pays dans la première colonne
    zhcult(icpt,1) = zread(1)
  endif

  ! on cherche l'indice de la culture correspondance
  do jj=1,ncrop
    if (int(zread(2))==ictype(jj,1)) then
      zhcult(icpt,ictype(jj,2)+2) = zhcult(icpt,ictype(jj,2)+2) + zread(3)
      exit
    endif
  enddo

enddo

close(12)

! on transforme les quantités d'hectares en pourcentages de cultures pour le pays
do jj = 1,npays
  zhcult(jj,4:6) = zhcult(jj,4:6) * 100. / sum(zhcult(jj,4:6))
enddo
  
! contient le code fao du pays associé au code dans notre carte des pays
open(13,file='liste_pays_fao_code.csv',form='formatted')
do jj = 1,npays
  read(13,fmt=*) icpays(jj,:)
enddo
close(13) 

! on remplace le code fao par le code dans notre carte des pays
do jj = 1,npays
  do ji = 1,npays
    if (int(zhcult(jj,1)) == icpays(ji,1)) then
      zhcult(jj,1) = float(icpays(ji,2))
      exit
    endif
  enddo
enddo


open(14,file='pourcentages_c3h_par_pays_b.csv',form='formatted')
open(15,file='pourcentages_c3e_par_pays_b.csv',form='formatted')
open(16,file='pourcentages_c4_par_pays_b.csv',form='formatted')
!open(17,file='pourcentages_lig_par_pays.csv',form='formatted')
!open(18,file='pourcentages_aut_par_pays.csv',form='formatted')

do jj=1,npays
  write(14,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') nint(zhcult(jj,1)),':',nint(zhcult(jj,1)),&
          ':',nint(zhcult(jj,4)),':',nint(zhcult(jj,4))
  write(15,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') nint(zhcult(jj,1)),':',nint(zhcult(jj,1)),&
          ':',nint(zhcult(jj,5)),':',nint(zhcult(jj,5))
  write(16,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') nint(zhcult(jj,1)),':',nint(zhcult(jj,1)),&
          ':',nint(zhcult(jj,6)),':',nint(zhcult(jj,6))
  !write(17,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') nint(zhcult(jj,1)),':',nint(zhcult(jj,1)),&
  !        ':',nint(zhcult(jj,2)),':',nint(zhcult(jj,2))
  !write(18,fmt='(i3.3,a1,i3.3,a1,i3.3,a1,i3.3)') nint(zhcult(jj,1)),':',nint(zhcult(jj,1)),&
  !        ':',nint(zhcult(jj,3)),':',nint(zhcult(jj,3))
enddo

close(14)
close(15)
close(16)
!close(17)
!close(18)

      END
